unit Unit6;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, DBTables, DBCtrls, DB, StdCtrls, Mask, Grids, Outline,
  Mdexplor, ExtCtrls, Connect, DBLookup;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    Table2: TTable;
    DataSource2: TDataSource;
    Table3: TTable;
    DataSource3: TDataSource;
    MDExplorer1: TMDExplorer;
    Panel1: TPanel;
    DBEdit3: TDBEdit;
    Table1CustNo: TFloatField;
    Table1Company: TStringField;
    Table2OrderNo: TFloatField;
    Table2CustNo: TFloatField;
    Table2AmountPaid: TCurrencyField;
    DBNavigator1: TDBNavigator;
    Table3OrderNo: TFloatField;
    Table3ItemNo: TFloatField;
    Table3PartNo: TFloatField;
    Table3Qty: TIntegerField;
    Table3Discount: TFloatField;
    DBEdit2: TDBEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    DBLookupCombo1: TDBLookupCombo;
    Table4: TTable;
    DataSource4: TDataSource;
    Panel2: TPanel;
    Label4: TLabel;
    Table4PartNo: TFloatField;
    Table4VendorNo: TFloatField;
    Table4Description: TStringField;
    Table4OnHand: TFloatField;
    Table4OnOrder: TFloatField;
    Table4Cost: TCurrencyField;
    Table4ListPrice: TCurrencyField;
    Table3Description: TStringField;
    procedure Table3BeforeInsert(DataSet: TDataset);
    procedure Table3NewRecord(DataSet: TDataset);
    procedure Table3DescriptionGetText(Sender: TField;
      var Text: OpenString; DisplayText: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  NextItemNo : Longint;

implementation

{$R *.DFM}

{ Get NextItemNo }
procedure TForm1.Table3BeforeInsert(DataSet: TDataset);
begin
if Table3.RecordCount > 0 then
  begin
  Table3.Last;
  NextItemNo := Table3ItemNo.AsInteger + 1;
  end
else
  begin
  NextItemNo := 1;
  end;
end;

{ We now change fields of new record to reflect
  the current order number and next item number }
procedure TForm1.Table3NewRecord(DataSet: TDataset);
begin
Table3OrderNo.AsInteger := Table2OrderNo.AsInteger;
Table3ItemNo.AsInteger := NextItemNo;
end;

procedure TForm1.Table3DescriptionGetText(Sender: TField;
  var Text: OpenString; DisplayText: Boolean);
begin
Text := Table4Description.AsString;
end;

end.
